#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>

#define O_WRITE (O_CREAT | O_TRUNC | O_WRONLY)
#define S_IRWUSR (S_IRUSR | S_IWUSR)

typedef unsigned char u8;
typedef unsigned short u16;

int
main(int argc, char *argv[])
{
	int i, fd;
	char *txt, *bin;
	struct stat sb;
	u16 alloc_size, db_size, rec_size, txt_size;
	u8 *data;

	if(argc < 3){
		fprintf(stderr, "Usage: txt2wa txt_file bin_file\n");
		exit(1);
	}

	txt = argv[1];
	bin = argv[2];

	if(stat(txt, &sb)){
		fprintf(stderr, "%s: stat failed\n", txt);
		exit(1);
	}
	txt_size = sb.st_size;

	if((fd = open(txt, O_RDONLY)) < 0){
		fprintf(stderr, "%s: open failed\n", txt);
		exit(1);
	}

	/* alloc_size:	2
	 * db_size:	2
	 * hdr_size:	1
	 * num_recs:	1
	 * rec_size:	2 (rec_size) + txt_size
	 */
	rec_size = txt_size + 2;
	db_size = rec_size + 6;
	alloc_size = (((db_size - 1) / 64) + 1) * 64;

	data = (u8 *)malloc(alloc_size);
	memset(data, 0, alloc_size);

	i = 0;
	memcpy(data+i, &alloc_size, 2); i += 2;
	memcpy(data+i, &db_size, 2); i += 2;
	data[i++] = 1;
	data[i++] = 1;
	memcpy(data+i, &rec_size, 2); i += 2;

	if(read(fd, data+i, txt_size) != txt_size){
		fprintf(stderr, "%s: read failed\n", txt);
		exit(1);
	}
	close(fd);

	if((fd = open(bin, O_WRITE, S_IRWUSR)) < 0){
		fprintf(stderr, "%s: open failed\n", bin);
		exit(1);
	}
	if(write(fd, data, alloc_size) != alloc_size){
		fprintf(stderr, "%s: write failed\n", bin);
		exit(1);
	}
	close(fd);

	free(data);

	exit(0);
}
